#include <stdio.h>
#include <stdlib.h>

#include "common.h"
#include "shmem.h"

//-----------------------------------------------------------------------------

int main(int argc, char* argv[]) {
  // Read parameters:
  char* ipcid=DEFAULT_DAEMONFILE;
  mac_addr adr;
  int base=1; 
  
  if(argc<=1) {
    fprintf(stderr,"MAC address and counterlist must be given\n");
    return 2;
  }
  
  if((argc>1) && (argv[1][0]=='-') && (argv[1][1]=='d')) {
    ipcid=argv[1]+2;
    base=2;
  }

  if(adr.fromstr(argv[base])) {
    fprintf(stderr,"Wrong format for MAC address\n");
    return 1;
  }
      
  int counterc=argc-base-1;
  int* counters=new int[counterc];
  for(int a=0; a<counterc; a++) {
    if(sscanf(argv[a+base+1],"%i",&counters[a])!=1 ||
       counters[a]<0 || counters[a]>=maxcounterc) {
      fprintf(stderr,"Illegal counter: %s\n",argv[a+base+1]);
      return 1;
    }
  }
  
  // Most parameters are read - contact the server:
  ShMemClient clnt;
  char* c=clnt.init(ipcid,1);
  if(c) {
    fprintf(stderr,"%s\n",c);
    return 1;
  }
  
  // And get the infomation:  
  ServerMem* ca=(ServerMem*)clnt.Lock();
  if(ca==0) {
    fprintf(stderr,"%s\n",LockErrString);
    return 1;
  }
  
  CardInfo Data;  // We read the data to this parameter

  if(adr.isBrdCast()) {
    // We should write totals - find them:
    for(int c=0; c<ca->curcardc; c++) 
      Data.add(ca->cards[c],ca->Counterc);
  } else {
    // We should write information for one particular card - find it:
    CardInfo search; search.macaddr=adr;
    CardInfo* ci=(CardInfo*)
      bsearch(&search,ca->cards,ca->curcardc,sizeof(CardInfo),CardInfo::compare_mac);
    if(ci!=0) Data=*ci;
  }
  clnt.UnLock(ca);
  
  // Now write the numberss. We only write the least significant part.
  for(int a=0; a<counterc; a++) {
    printf("%u\n",Data.Counters[counters[a]].ls);
  }
  
  return 0;
}